import numpy as np

def inicializarLaberinto():
    laberinto = np.zeros([10, 10])
    paredes = np.array([[0, 2], [0, 7],[1, 0], [1, 2], [1, 5], [1, 6], [1, 8],[2,6],[2,8],[3,1],[3,4],[3,5],[3,6],[4,2],[4,3],[4,7],[5,5],[5,7],[6,0],[6,3],[6,4],[6,7],[6,9],[7,1],[7,2],[7,8],[7,9],[8,2],[8,4],[8,5]])
    laberinto[paredes[:, 0], paredes[:, 1]] = np.inf
    return laberinto


def esFactible(laberinto,f,c):
    if f>=0 and f<np.size(laberinto,0) and c>=0 and c<np.size(laberinto,1):
        return laberinto[f][c] == 0
    else:
        return False

def salirDelLaberinto(laberinto,esSol,f,c,k):
    if f == np.size(laberinto,0)-1 and c == np.size(laberinto,1)-1:
        esSol = True
    else:
        desplazamientos=np.array([[1,0],[0,1],[-1,0],[0,-1]])
        i = 0
        while not esSol and i < np.size(desplazamientos,0):
            if esFactible(laberinto,f+desplazamientos[i,0],c+desplazamientos[i,1]):
                laberinto[f+desplazamientos[i,0],c+desplazamientos[i,1]] = k
                [laberinto,esSol] = salirDelLaberinto(laberinto,esSol,f+desplazamientos[i,0],c+desplazamientos[i,1],k+1)
                if not esSol:
                    laberinto[f + desplazamientos[i, 0], c + desplazamientos[i, 1]] = 0
            i += 1
    return [laberinto,esSol]

# Prog Ppal:
laberinto = inicializarLaberinto()
f = 0
c = 0
k = 1
laberinto[f][c] = k
esSol = False
[laberinto,esSol] = salirDelLaberinto(laberinto,esSol,f,c,k+1)
print(laberinto)