import numpy as np

def ordenar(coleccion):
    for j in range(1,len(coleccion)):
        clave = coleccion[j][:]
        # Insertar la clave en la secuencia ordenada:
        i = j - 1
        while i >= 0 and coleccion[i][2] > clave[2]:
            coleccion[i + 1][:] = coleccion[i][:]
            i = i - 1
        coleccion[i+1][:] = clave[:]
    return coleccion

def actualizarCompConexas(compConexas,aristaInf,aristaSup):
    for i in range(len(compConexas)):
        if compConexas[i] == compConexas[int(aristaSup) - 1]:
            compConexas[i] = compConexas[int(aristaInf) - 1]
    return compConexas

def Kruskal(aristas,n):
    aristas = ordenar(aristas)
    compConexas = range(n) # inicializamos las componentes conexas
    nComp = n
    i = 0
    sol = []
    while nComp > 1 and i < len(aristas):
        if compConexas[aristas[i][0]-1] != compConexas[aristas[i][1]-1]:
            compConexas = actualizarCompConexas(compConexas,aristas[i][0],aristas[i][1])
            nComp -= 1
            # sol.append([aristas[i,0],aristas[i,1]])
            sol.append(list((aristas[i,:])))
        i += 1
    return sol

# Prog Ppal:
aristas = [ [3, 4 ,3], [2, 6, 4], [3, 7, 5], [1, 7, 6], [1, 3, 1], [4, 5, 1], [1, 4, 2], [2, 5, 2], [2, 7, 7], [5, 7, 8], [4, 6, 9]]
n = 7
sol = Kruskal(aristas,n)
print(sol)