def ordenar(coleccion):
    for j in range(1,len(coleccion)):
        clave = coleccion[j][:]
        # Insertar la clave en la secuencia ordenada:
        i = j - 1
        while i >= 0 and coleccion[i][3] < clave[3]:
            coleccion[i + 1][:] = coleccion[i][:]
            i = i - 1
        coleccion[i+1][:] = clave[:]
    return coleccion

def calculaDensidadValor(objetos):
    for i in range(len(objetos)):
        objetos[i].append(objetos[i][2] / objetos[i][1])
    return objetos

def Inicializar(longitud):
    solucion = []
    for i in range(longitud):
        solucion.append(0)
    return solucion

def rellenarMochila(objetos,W):
    # datos es una lista de pares [id, peso, valor]
    objetos = calculaDensidadValor(objetos) # Los tratamos para añadir porcentaje
    objetos = ordenar(objetos) # ordenamos decrecientemente por v /w
    solucion = [0] * len(objetos) # InicializarSolucion
    peso = 0
    i = 0
    while peso < W:
        if peso + objetos[i][1] <= W:
            peso += objetos[i][1]
            solucion[objetos[i][0]] = 1
            i += 1
        else:
            solucion[objetos[i][0]] = (W - peso) / objetos[i][1]
            peso = W
    return solucion

# Prog Ppal:
# Entrada
objetos = [[0,10,20],[1,20,30],[2,30,66],[3,40,40],[4,50,60]]
W = 100
print(objetos)
solucion = rellenarMochila(objetos,W)
print(solucion)
