def ordenarXEdad(participantes):
    for j in range(1,len(participantes)):
        participante = participantes[j][:]
        # Insertar la clave en la secuencia ordenada:
        i = j - 1
        while i >= 0 and participantes[i][0] > participante[0]:
            participantes[i + 1] = participantes[i][:]
            i = i - 1
        participantes[i+1] = participante[:]
    return participantes

def seconddates(participantes, k): #voraces
    equipo_jovenes = [] #iniciar solucion
    sol = 0
    while (not (participantes == []) ) and sol < k: #bucle iterativa
        # mientras haya candidatos, o no hayamos encontrado la solución
        #cogemos el candidato más prometedor
        participante = participantes[0] #cojo el primero
        participantes = participantes[1:] # quitando el primero, participantes.pop(0)
        #comprobar si es factible incluir el candidato a la solución
        #en este caso no hay restricciones
        equipo_jovenes.append(participante) #añadimos a la solucion
        sol +=1 #contador para saber cuando llegaremos a la solucion


    for p in equipo_jovenes: #una vez salimos del bucle = tenemos solución
        print(p[1], end=' ')
    print()
    for p in participantes:
        print(p[1], end=' ')


n, k = map(int, input().strip().split())
participantes = []
for i in range(n):
    nombre, edad = input().strip().split()
    edad = int(edad)
    participantes.append((edad, nombre))
print(participantes)

participantes = ordenarXEdad(participantes)

seconddates(participantes, k)