import numpy as np

def esSolucion(cuadrado,N):
    cteMag = N * (N ** 2 + 1) / 2
    sumaD1 = 0
    sumaD2 = 0
    for k in range(N):
        sumaD1 += cuadrado[k,k]
        sumaD2 += cuadrado[k,N-1-k]
    esCuadradoMag = sumaD1 == cteMag and sumaD2 == cteMag
    f = 0
    while esCuadradoMag and f < N:
        esCuadradoMag = np.sum(cuadrado[f,:]) == cteMag
        f+=1
    c = 0
    while esCuadradoMag and f < N:
        esCuadradoMag = np.sum(cuadrado[:, c]) == cteMag
        c+=1
    return esCuadradoMag

def esFactible(cuadrado,i,j,N,num):
    if cuadrado[i,j] == 0 and num not in cuadrado:
        cteMag = N * (N ** 2 + 1) / 2
        fila = np.sum(cuadrado[i,0:j]) + num <= cteMag
        columna = np.sum(cuadrado[0:i,j]) + num  <= cteMag
        if i==j: # Diag Ppal
            suma = 0
            for k in range(i):
                suma += cuadrado[k,k]
            diag1 = suma + num <= cteMag
        else:
            diag1=True
        if i+j==N-1: # Diag Sec
            suma = 0
            for k in range(i):
                suma += cuadrado[k, N-k-1]
            diag2 = suma + num <= cteMag
        else:
            diag2 = True
        return fila and columna and diag1 and diag2
    else:
        return False

def rellenarCuadrado(cuadrado,N,pos,esSol):
    if pos >= N**2:
        esSol = esSolucion(cuadrado,N)
    else:
        i = pos // N
        j = pos % N
        num = 1
        while not esSol and num <= N**2:
            if esFactible(cuadrado,i,j,N,num):
                cuadrado[i,j] = num
                [cuadrado, esSol] = rellenarCuadrado(cuadrado, N, pos+1, esSol)
                if not esSol:
                    cuadrado[i, j] = 0
            num += 1
    return [cuadrado,esSol]


# Prog Ppal:
N = 3
cuadrado = np.zeros([N,N],dtype=int)
pos = 0
[cuadrado,esSol] = rellenarCuadrado(cuadrado,N,pos,False)
#cuadrado = np.array([[2,7,6],[9,5,1],[4,3,8]])
#esSol = esSolucion(cuadrado,N)
if esSol:
    print(cuadrado)
else:
    print('No se ha encontrado una solución')
