import numpy as np

def peso(sol,objetos):
    pesoSol = 0
    for i in range(len(sol)):
        pesoSol += sol[i] * objetos[i, 0]
    return pesoSol

def esSolucion(solucion,objetos,W):
    return peso(solucion,objetos) + np.min(objetos[:,0]) > W

def valor(sol,objetos):
    valorSol = 0
    for i in range(len(sol)):
        valorSol += sol[i] * objetos[i, 1]
    return valorSol

def mejor(sol1,sol2,objetos):
    if valor(sol1,objetos) > valor(sol2,objetos):
        return np.copy(sol1)
    else:
        return np.copy(sol2)

def esPrometedor(solucion,objetos,W,k):
    return peso(solucion,objetos) + objetos[k,0] <= W

def mochila(solucion,mejorSol,objetos,W,k):
    if esSolucion(solucion,objetos,W):
        mejorSol = mejor(mejorSol,solucion,objetos)
    else:
        for i in range(k,np.size(objetos,0)):
            if esPrometedor(solucion,objetos,W,i):
                solucion[i] += 1
                [solucion,mejorSol] = mochila(solucion,mejorSol,objetos,W,i)
                solucion[i] -= 1
    return [solucion,mejorSol]


# Prog Ppal
# datos:
W = 8
n = 4
objetos = np.array([[2,3],[3,5],[4,6],[5,10]])
solucion = np.zeros(n)
mejorSol = np.zeros(n)
[solucion,mejorSol] = mochila(solucion,mejorSol,objetos,W,0)
print(mejorSol)