import numpy as np

def esFactible(cuadrado,fil,col,num):
    N = len(cuadrado)
    numMagico = (N*(N**2+1))//2
    if num in cuadrado:
        return False
    else:
        filaOk = (col == N-1 and (np.sum(cuadrado[fil,:col]) + num) == numMagico) or (col < N-1 and (np.sum(cuadrado[fil,:col]) +num) < numMagico)
        colOk = (fil == N -1 and (np.sum(cuadrado[:fil,col]) + num) == numMagico) or (fil < N -1 and (np.sum(cuadrado[:fil,col]) +num)< numMagico)
        if fil == col:
            sumaDiag = 0
            for i in range(fil):
                sumaDiag += cuadrado[i,i]
            diag1Ok = (fil == N-1 and sumaDiag + num == numMagico) or (fil < N-1 and sumaDiag+num < numMagico)
        else:
            diag1Ok = True
        if fil + col == N-1:
            sumaDiag = 0
            for i in range(fil):
                sumaDiag += cuadrado[i,N-1-i]
            diag2Ok = (fil == N - 1 and sumaDiag + num == numMagico) or (fil < N - 1 and sumaDiag + num < numMagico)
        else:
            diag2Ok = True
        return filaOk and colOk and diag1Ok and diag2Ok

def cuadradoVA(cuadrado,i,esSol):
    if i == np.size(cuadrado):
        esSol = True
    else:
        fil = i//len(cuadrado)
        col = i % len(cuadrado)
        num=1
        while not esSol and num < np.size(cuadrado)+1:
            if esFactible(cuadrado,fil,col,num):
                cuadrado[fil,col] = num
                [cuadrado,esSol] = cuadradoVA(cuadrado,i+1,esSol)

            num+=1
        if not esSol:
            cuadrado[fil,col] = 0

    return [cuadrado,esSol]

#Prog Ppal:
N = 4
cuadrado = np.zeros([N,N],dtype=int)
[cuadrado,esSol] = cuadradoVA(cuadrado,0,False)
print(cuadrado)