# METHODS
def isSolucion(cuadrado, cm):
    isZero = True
    for i in range(len(cuadrado)):
        for j in range(len(cuadrado[i])):
            if (cuadrado[i][j] == 0):
                isZero = False

    loEs = isFactible(cuadrado, cm)

    return isZero and loEs


def isFactible(cuadrado, fila, columna, ini):
    tam = len(cuadrado)
    cm = (tam * ((pow(tam, 2)) + 1)) // 2
    isOk = True
    isOkDI=True
    isOkDD=True
    for k in range(len(cuadrado)):
        if (ini in cuadrado[k]):
            isOk = False
    if (isOk):
        cuadrado[fila][columna] = ini
        if (columna == (tam - 1) and sum(cuadrado[fila])==cm) or (columna<(tam-1) and sum(cuadrado[fila])<cm):
            isOkH = True
        else:
            isOkH=False

        #Como Python 3 no permite expresiones tales que cuadrado[:][columna], se debe recurrir a una manera más manual
        suma=0
        for j in range(len(cuadrado[columna])):
            suma+=cuadrado[j][columna]
        if(fila==(tam-1) and suma==cm) or (fila<(tam-1) and suma<cm):
            isOkV=True
        else:
            cosa=sum(cuadrado[:][columna])
            isOkV=False
        if(fila==columna):
            sumaDD=0
            for i in range(tam):
                sumaDD+=cuadrado[i][i]
            if(fila==(tam-1) and sumaDD==cm) or (fila<(tam-1) and sumaDD<cm):
                isOkDD=True
            else:
                isOkDD=False
        if(fila+columna==tam-1):
            sumaDI=0
            for i in range(tam):
                sumaDI+=cuadrado[i][tam-1-i]
            if(fila==(tam-1) and sumaDI==cm) or (fila<(tam-1) and sumaDI<cm):
                isOkDI=True
            else:
                isOkDI=False
        if not(isOkH and isOkV and isOkDI and isOkDD):
            isOk=False
        cuadrado[fila][columna] = 0
    return isOk


def cuadradoMagico(cuadrado, isSol, ini):
    if (ini == len(cuadrado) ** 2):
        isSol = True
    else:
        fila = ini // len(cuadrado)
        columna = ini % len(cuadrado)
        num = 1
        while not isSol and num < ((len(cuadrado) ** 2) + 1):
            if (isFactible(cuadrado, fila, columna, num)):
                cuadrado[fila][columna] = num
                [cuadrado, isSol] = cuadradoMagico(cuadrado, isSol, ini + 1)
            num += 1
        if not isSol:
            cuadrado[fila][columna] = 0
    return [cuadrado, isSol]


# MAIN
filas = 3
columnas = 3
cuadrado = [[0 for x in range(filas)] for y in range(columnas)]
[cuadrado, isSol] = cuadradoMagico(cuadrado, False, 0)
for i in range(len(cuadrado)):
    print(cuadrado[i])