import numpy as np

def busquedaTernaria(A,ini,fin,x):
    if ini > fin:
        return False
    else:
        tercio1 = ini + (fin - ini) // 3
        if x == A[tercio1]:
            return True
        else:
            if x < A[tercio1]:
                return busquedaTernaria(A,ini,tercio1-1,x)
            else:
                tercio2 = ini + 2 * (fin - ini) // 3
                if x == A[tercio2]:
                    return True
                else:
                    if x < A[tercio2]:
                        return busquedaTernaria(A,tercio1+1,tercio2-1,x)
                    else:
                        return busquedaTernaria(A,tercio2+1,fin,x)

def busquedaTernariaMod(A,ini,fin,x):
    dibujar(A, ini, fin)
    if ini > fin:
        return False
    else:
        tercio1 = ini + (fin - ini) // 3
        if x == A[tercio1]:
            return True
        else:
            if x < A[tercio1]:
                return busquedaTernariaMod(A,ini,tercio1-1,x)
            else:
                tercio2 = ini + 2 * (fin - ini) // 3
                if x == A[tercio2]:
                    return True
                else:
                    if x < A[tercio2]:
                        return busquedaTernariaMod(A,tercio1+1,tercio2-1,x)
                    else:
                        return busquedaTernariaMod(A,tercio2+1,fin,x)

def dibujar(A,ini,fin):
    for i in range(len(A)):
        if i == ini:
            print('[', end = '')
        print(A[i], ' ',end = '')
        if i == fin:
            print(']', end = '')
    print()


# Prog Ppal:
A =np.array(list(range(-7,50,2)))
print(A)
print(busquedaTernariaMod(A,0,len(A)-1,47))