import numpy as np

def teselar(tablero,celda0X,celda0Y,xIni,yIni,xFin,yFin,n):
    if xFin - xIni == 1:
        aux = tablero[celda0X,celda0Y]
        tablero[xIni:xFin+1,yIni:yFin+1] = n
        tablero[celda0X, celda0Y] = aux
    else:
        # Cuadrantes:
        # 1 2
        # 3 4
        # Cuadrante 1: de xIni,yIni a xMed,yMed
        # Cuadrante 2: de xIni,yMed+1 a xMed,yFin
        # Cuadrante 3: de xMed+1,yIni a xFin,yMed
        # Cuadrante 4: de xMed+1,yMed+1 a xFin,yFin
        xMed = (xIni + xFin) // 2
        yMed = (yIni + yFin) // 2
        if celda0X <= xMed:
            if celda0Y <= yMed: # La celda0 está en el cuadrante 1
                #tablero[xMed, yMed] = n  # Cuadrante 1
                tablero[xMed,yMed+1]=n # Cuadrante 2
                tablero[xMed+1, yMed] = n # Cuadrante 3
                tablero[xMed+1, yMed + 1] = n # Cuadrante 4
                teselar(tablero, celda0X, celda0Y, xIni, yIni, xMed, yMed, n+1) # Cuadrante 1
                teselar(tablero, xMed, yMed + 1, xIni, yMed+1, xMed, yFin, n+2) # Cuadrante 2
                teselar(tablero, xMed+1, yMed, xMed+1, yIni, xFin, yMed, n+3) # Cuadrante 3
                teselar(tablero, xMed+1, yMed + 1, xMed+1, yMed+1, xFin, yFin, n+4) # Cuadrante 4
            else: # La celda0 está en el cuadrante 2
                tablero[xMed, yMed] = n # Cuadrante 1
                # tablero[xMed,yMed+1]=n # Cuadrante 2
                tablero[xMed + 1, yMed] = n # Cuadrante 3
                tablero[xMed + 1, yMed +1] = n # Cuadrante 4
                teselar(tablero, xMed, yMed, xIni, yIni, xMed, yMed, n + 1) # Cuadrante 1
                teselar(tablero, celda0X, celda0Y, xIni, yMed + 1, xMed, yFin, n + 2) # Cuadrante 2
                teselar(tablero, xMed + 1, yMed, xMed + 1, yIni, xFin, yMed, n + 3) # Cuadrante 3
                teselar(tablero, xMed + 1, yMed + 1, xMed + 1, yMed + 1, xFin, yFin, n + 4) # Cuadrante 4
        else:
            if celda0Y <= yMed:  # La celda0 está en el cuadrante 3
                tablero[xMed, yMed] = n # Cuadrante 1
                tablero[xMed, yMed + 1] = n # Cuadrante 2
                # tablero[xMed + 1, yMed] = n # Cuadrante 3
                tablero[xMed + 1, yMed + 1] = n # Cuadrante 4
                teselar(tablero, xMed, yMed, xIni, yIni, xMed, yMed, n + 1)
                teselar(tablero, xMed, yMed + 1, xIni, yMed+1, xMed, yFin, n+2)
                teselar(tablero, celda0X, celda0Y, xMed + 1, yIni, xFin, yMed, n + 3)
                teselar(tablero, xMed+1, yMed + 1, xMed+1, yMed+1, xFin, yFin, n+4)
            else:  # La celda0 está en el cuadrante 4
                tablero[xMed, yMed] = n
                tablero[xMed, yMed + 1] = n
                tablero[xMed + 1, yMed] = n
                # tablero[xMed + 1, yMed + 1] = n # Cuadrante 4
                teselar(tablero, xMed, yMed, xIni, yIni, xMed, yMed, n + 1)
                teselar(tablero, xMed, yMed + 1, xIni, yMed+1, xMed, yFin, n+2)
                teselar(tablero, xMed + 1, yMed, xMed + 1, yIni, xFin, yMed, n + 3)
                teselar(tablero, celda0X, celda0Y, xMed+1, yMed+1, xFin, yFin, n+4)

    return tablero

# Prog Ppal:
tablero = np.zeros([8,8],dtype=int)
celda0X = 3
celda0Y = 1
tablero[celda0X,celda0Y] = -1
xIni = 0
yIni = 0
xFin = len(tablero)-1
yFin = len(tablero)-1
n = 1
inc = 0
tablero = teselar(tablero,celda0X,celda0Y,xIni,yIni,xFin,yFin,n)
print(tablero)