import numpy as np

def completarTabla(tabla,  jugInf, jugSup, rondaInf, rondaSup, jugInic):
    fila = np.array(range(jugInic,jugInic + (rondaSup-rondaInf)+1))
    for i in range(jugInf,jugSup+1):
        tabla[i,rondaInf:rondaSup+1] = fila
        aux = fila[-1]
        for j in range(len(fila)-2,-1,-1):
            fila[j+1] = fila[j]
        fila[0] = aux
    return tabla

def formarTabla(tabla,inf,sup):
    if sup-inf == 1:
        tabla[inf,0] = sup
        tabla[sup,0] = inf
    else:
        med = (inf + sup) // 2
        formarTabla(tabla, inf, med)
        formarTabla(tabla, med+1, sup)
        completarTabla(tabla,  inf, med, med-inf, 2* (med-inf), med+1)
        completarTabla(tabla, med+1, sup, med-inf, 2* (med-inf), inf)
    return tabla


# Prog Ppal:
tabla = np.zeros((16,15),dtype=int)
tabla = formarTabla(tabla,0,15)
print(tabla + 1)