
def esValida(candidata,tablero):
    return candidata[0] >= 0 and candidata[0] < len(tablero) and candidata[1] >= 0 and candidata[1] < len(tablero[0]) and tablero[candidata[0]][candidata[1]] == 0

def contar(casillaActual,tablero):
    movimientos = [[-2, 1], [-1, 2], [1, 2], [2, 1], [-2, -1], [-1, -2], [1, -2], [2, -1]]
    accesibles = 0
    for mov in movimientos:
        casillaCandidata = [casillaActual[0] + mov[0],casillaActual[1] + mov[1]]
        if esValida(casillaCandidata, tablero):
            accesibles += 1
    return accesibles

def siguienteCasilla(tablero, casillaActual):
    movimientos = [[-2, 1], [-1,2], [1,2], [2,1],[-2, -1], [-1,-2], [1,-2], [2,-1]]
    minNumAccesibles = 999999
    siguienteCasilla = [-1, -1]
    for mov in movimientos:
        casillaCandidata = [casillaActual[0] + mov[0],casillaActual[1] + mov[1]]
        if esValida(casillaCandidata,tablero):
            numAccesibles = contar(casillaCandidata,tablero)
            if numAccesibles < minNumAccesibles:
                minNumAccesibles = numAccesibles
                siguienteCasilla = casillaCandidata
    return siguienteCasilla


def recorridoCaballo(tablero,casillaInic):
    casillaActual = casillaInic
    turno = 1
    while not casillaActual == [-1,-1]:
        tablero[casillaActual[0]][casillaActual[1]] = turno
        casillaActual = siguienteCasilla(tablero, casillaActual)
        turno += 1
    return tablero


# Prog Ppal:
tablero =  [ ]
for i in range ( 8 ):
    tablero.append ( [ 0 ]*8 )

tablero = recorridoCaballo(tablero,[2,1])
print(tablero)